/*
    XHEDGEHOG v0.0.4... quasi-playable demo of a Sonic-like X Windows game.
    Copyright (c) 1996 Jeff Read. All rights reserved.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    See the file, COPYING, for more details.
*/
#define XK_MISCELLANY
#define XK_LATIN1
#include <typeinfo>
#include <curses.h>
#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/keysym.h>
#include <sprite.h>
#include <mfsprite.h>
#include <stdio.h>
#include <stdlib.h>
#include "xhdemo4.h"
#include "xhtile.h"

extern char **Xhpix[];

#define sgn(x) (x < 0 ? -1 : (x == 0 ? 0 : 1))

int AirJordan = 0;
//int Score = 0; int Time = 0; int Rings = 0;
Display *d;
char *tile_data[] = {
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                                            ",
"                                E                           ",
"                                D                           ",
"                       E        D                           ",
"          E            D        D                           ",
"   E      D      E     D        D        BBBBBBBBBB         ",
"   D      D      D     D        D        AAAAAAAAAA         ",
"   D      D      D     D        D        AAAAAAAAAA         ",
"BBBCBBBBBBCBBBBBBCBBBBBCBBBBBBBBCBBBBBBBBBBBBBBBBBBBBBBBBBBB",
"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",
"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",
"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
};

Pixmap Stand_pxm[2],Step_pxm[2],Spin_pxm[2],Run_pxm[2],
  Stand_mask[2],Step_mask[2],Spin_mask[2],Run_mask[2];
Pixmap Tile_pxm[5],Tile_mask[5];
Pixmap Ring_pxm,Ring_mask;
Pixmap Glitter_pxm,Glitter_mask;
Pixmap background;

void reset_keyb();
class XhDemoWin : public SpriteAppWin {
  Sonic *s;
public:
  TileSprite *tspr;
  XhDemoWin(Display *dpy) : SpriteAppWin(dpy,"Xhedgehog Demo 4",400,300) {
    int f;
    /*int c;
    Colormap m = XCreateColormap(theDisplay(),theWindow(),
				 DefaultVisual(theDisplay(),
					       DefaultScreen(theDisplay())),
				 AllocAll);
    XColor col[256];
    for(c=0;c<64;c++) {
      unsigned int R,G,B;
      R = (c & 0x60) * 1024;
      G = (c & 0x0C) * 4096;
      B = (c & 0x03) * 16384;
      col[c].red = R;
      col[c].green = G;
      col[c].blue = B;
      col[c].pixel = c;
      col[c].flags = DoRed | DoGreen | DoBlue;
    }    
    XStoreColors(theDisplay(),m,col,64);
    XSetWindowColormap(theDisplay(),theWindow(),m);
    cmap = m;*/
    XpmAttributes attr;
    attr.valuemask = XpmColormap | XpmCloseness;
    attr.colormap = cmap;
    attr.closeness = 20000;
    Pixmap bg;
    f = LoadPixmap(Xhpix[8],&background,&bg);
    XCopyArea(theDisplay(),background,Backpxm,bufgc,0,0,cx,cy,0,0);
    f = LoadPixmap(Xhpix[0],&(Stand_pxm[0]),&(Stand_mask[0]));
    LoadPixmap(Xhpix[1],&(Step_pxm[0]),&(Step_mask[0]));
    LoadPixmap(Xhpix[2],&(Spin_pxm[0]),&(Spin_mask[0]));
    LoadPixmap(Xhpix[3],&(Run_pxm[0]),&(Run_mask[0]));
    LoadPixmap(Xhpix[4],&(Stand_pxm[1]),&(Stand_mask[1]));
    LoadPixmap(Xhpix[5],&(Step_pxm[1]),&(Step_mask[1]));
    LoadPixmap(Xhpix[6],&(Spin_pxm[1]),&(Spin_mask[1]));
    LoadPixmap(Xhpix[7],&(Run_pxm[1]),&(Run_mask[1]));
    for(int z=0;z<5;z++) {
      LoadPixmap(Xhpix[z + 9],&(Tile_pxm[z]),&(Tile_mask[z]));
    }
    LoadPixmap(Xhpix[14],&Ring_pxm,&Ring_mask);
    LoadPixmap(Xhpix[15],&Glitter_pxm,&Glitter_mask);
    tspr = new TileSprite(this,60,22,Tile_pxm,Tile_mask,tile_data);
    s = new Sonic(this);
    new Ring(this,300,100);
    new Ring(this,327,100);
    new Ring(this,354,100);
    s->walk_flag = True;
}
  void ProcessEvent(XEvent *evt) {
    KeySym ks;
    switch(evt->type) {
    case KeyPress:
      ks = XLookupKeysym((XKeyEvent *)evt,0);
      switch(ks) {
      case XK_Escape:
	Quit();
      case XK_Right:
	s->dir = 0;
	if(!(s->jump_flag)) {
	  s->walk_flag = 1;
	  s->accel = 1.5;
	  s->SetWalkShape();
	}
	break;
      case XK_Left:
	s->dir = 1;
	if(!(s->jump_flag)) {
	  s->walk_flag = 1;
	  s->accel = -1.5;
	  s->SetWalkShape();
	}
	break;
      case XK_space:
	if((!AirJordan) && s->jump_flag) {
	  break;
	}
	s->walk_flag = 0;
	s->jump_flag = 1;
	s->SetSpinShape();
	s->vy = -10;
	break;
      }
      XSync(display,False);
      break;
    case KeyRelease:
      ks = XLookupKeysym((XKeyEvent *)evt,0);
      switch(ks) {
      case XK_Right:
	s->accel = -2;
	break;
      case XK_Left:
	s->accel = 2;
	break;
      }
      XSync(display,False);
      break;
    }
  }
};

void Sonic::MoveSprite(float newx,float newy) {
  char d[80];
  sprintf(d,"Pos:%d,%d      ",(int)(XPos()),(int)(YPos()));
  mvaddstr(1,0,d);
  refresh();
  int tx = newx + (cx / 2); int ty = newy + cy;
  int f = ((XhDemoWin *)host)->tspr->FetchTile(tx,ty);
  ty -= (ty % TILE_SIZE);
  if(f == 'B' || f == 'C') {
    if(vy > 0) {
      vy = 0;
      if(!walk_flag) {      
	if(vx == 0) SetStandShape();
	else if(abs(vx) >= 8) SetRunShape(); else SetWalkShape();
	newy = ty - cy + 6;
	jump_flag = 0;
	walk_flag = 1;
      }
    }
  }
  else {
    walk_flag = 0;
    if(!jump_flag)
      vy += 0.5;
  }
  __MoveSprite(newx,newy);
  if(jump_flag) {vy += 0.5;
/*  if(y > 200) {
    y = 200;
    vy = 0;
    jump_flag = 0;
    walk_flag = 1;
    if(vx == 0) SetStandShape();
    else SetWalkShape();
  }
  */
  }
  if(walk_flag) {
    if(frame % 4 == 0) {
      if(abs(vx) <= 10) {
	float tvx = abs(vx);
	vx += accel;
	if((tvx >= 7) && (abs(vx) < 7)) {
	  SetWalkShape();
	}
	if((tvx < 7) && (abs(vx) >= 7)) {
	  SetRunShape();
	}
      }
      else {
	vx = 10 * sgn(vx);
	accel = 0;
      }
    }
    switch(dir) {
    case 0:
      if(vx < 0) {vx = 0; accel = 0; SetStandShape();}
      break;
    case 1:
      if(vx > 0)  {vx = 0; accel = 0;SetStandShape();}
      break;
    }
  }
}

Sonic::Sonic(SpriteAppWin *sw) : MultiframeSprite(sw,32,200,Stand_pxm[0],
						  Stand_mask[0],1,2) {
  roll_flag = 0;
  walk_flag = 0;
  jump_flag = 0;
  accel = 0;
  dir = 0;
  auto_animate = True;
}

void Sonic::SetStandShape() {
  ChangeSpriteShape(Stand_pxm[dir],Stand_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
}

void Sonic::SetWalkShape() {
  ChangeSpriteShape(Step_pxm[dir],Step_mask[dir]);
  SetMaxFrames(8);
  SetFrame(0);
}

void Sonic::SetSpinShape() {
  ChangeSpriteShape(Spin_pxm[dir],Spin_mask[dir]);
  SetMaxFrames(5);
  SetFrame(0);
}

void Sonic::SetRunShape() {
  ChangeSpriteShape(Run_pxm[dir],Run_mask[dir]);
  SetMaxFrames(4);
  SetFrame(0);
}


void main(int argc,char *argv[]) {
  for(int a=0;a<argc;a++) {
    if(!strcmp(argv[a],"-airjordan")) {
      AirJordan = 1;
    }
  }
  initscr(); raw(); noecho(); nonl();
  mvaddstr(0,0,"XHEDGEHOG 0.0.4 by BitWizE (Jeff Read)");
  XEvent evt;
  d = XOpenDisplay(NULL);
  XAutoRepeatOff(d);
  XhDemoWin *sw = new XhDemoWin(d);
  printf( 	"Xhedgehog v0.0.4\n"
		"QUASI-PLAYABLE demo\n"
		"by Jeff Read\n");
  sw->Run();
  reset_keyb();
  XCloseDisplay(d);
  endwin();
}

void reset_keyb() {
XKeyboardControl xkc;
xkc.auto_repeat_mode = AutoRepeatModeDefault;
//XChangeKeyboardControl(d,KBAutoRepeatMode,&xkc);
XAutoRepeatOn(d);
}

void Sonic::__MoveSprite(float newx,float newy) {
  float tx = x;
  float ty = y;
  XhDemoWin *w = (XhDemoWin *)host;
  MultiframeSprite::MoveSprite(newx,newy);
  if(
     (
      (
       (w->tspr->XPos() <= (w->tspr->TMapWidth() - 1) * TILE_SIZE
	- w->XSize()) &&
       (newx - w->tspr->XPos() >= (w->XSize() * 2 / 3)) && (!dir)
       ) ||
      (
       (w->tspr->XPos() >= 0) &&
       (newx - w->tspr->XPos() <= (w->XSize() / 3)) && (dir)
       )
      ) &&
     ((newx) >= (w->XSize() / 3) &&
      (newx) <= (w->tspr->TMapWidth() * TILE_SIZE
				   - w->XSize() / 3))
     ) {
    w->tspr->MoveSprite(w->tspr->XPos() + newx - tx,w->tspr->YPos());
  }
}

Ring::Ring(SpriteAppWin *sw,float _x,float _y) :
  MultiframeSprite(sw,_x,_y,Ring_pxm,Ring_mask,6,2) {
    auto_animate = True; auto_hittest = True;
    g = 0; c = 0;
}

void Ring::MoveSprite(float newx,float newy) {
  MultiframeSprite::MoveSprite(newx,newy);
  if(g) {
    c++; if(c >= 5) Nuke();
  }
}
void Ring::OnHitTest(Sprite *s) {
  if(!g) {
    if(dynamic_cast<Sonic *>(s) != NULL) {
      SetGlitter();
    }
  }
}

void Ring::RenderSprite(Drawable d) {
  XhDemoWin *xw = (XhDemoWin *)host;
  float tempx,tempy;
  tempx = x; tempy = y;
  x -= xw->tspr->XPos();
  y -= xw->tspr->YPos();
  MultiframeSprite::RenderSprite(d);
  x = tempx;
  y = tempy;
}

void Ring::SetGlitter() {
  g = 1;
  ChangeSpriteShape(Glitter_pxm,Glitter_mask);
  SetMaxFrames(4);
}

void Sonic::RenderSprite(Drawable d) {
  XhDemoWin *xw = (XhDemoWin *)host;
  float tempx,tempy;
  tempx = x; tempy = y;
  x -= xw->tspr->XPos();
  y -= xw->tspr->YPos();
  MultiframeSprite::RenderSprite(d);
  x = tempx;
  y = tempy;
}
